// SCcon.cpp : Defines the entry point for the application.
//

//#include "stdafx.h"
//#include	"stdafx.h"
//#include "../winvnc/winvnc/stdhdrs.h"
#include	<stdio.h>
#include	<windows.h>
#include	<winsock.h>
#include	<process.h>
#include    <stdlib.h>
#include <tchar.h>
#include	"tcptunnel.h"
#include "../vncviewer/Log.h"
#define LL_STATE 0

#define SSLCLIENT
#define HTTP_PORT 80
#define HTTPS_PORT 443
#define MAX_HOST_NAME_LEN 256
//#define SSLSERVER
HKEY hkLocal=NULL;
bool regblocked;
TCHAR REGISTRY_KEY [] = "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";
char viewerhost[150];
TCHAR remotehost3[256];
int remoteport3=0;
HINSTANCE g_hInst=NULL;
extern HINSTANCE	m_hInstResDLL;
extern TCHAR g_proxyhost[256];
extern Log vnclog;
extern bool g_stop;

#ifdef __cplusplus
extern "C" {
int mainconnect( int argc, char **argv );
char * readpass( const char* prompt, ...);
}
#endif

TCPTunnelServer::TCPTunnelServer(
	int cPort,char* ipAddr,int bePort)
{
	clientPort = cPort;
	strcpy(BackEndServerIPAddr, ipAddr);
	BackEndServerPort = bePort;
	
	WSADATA			Data;
	int status = WSAStartup(MAKEWORD(1,1), &Data);
	if (status != 0)
		throw SocketPanic(0,"ERROR:WSAStartup unsuccessful\n");

	if (matrixSslOpen() < 0) {
		throw SocketPanic(0, "Ssl failed, exiting...\n");
	}
#ifdef SSLCLIENT
	sessionId = NULL;
	if (matrixSslReadKeys(&keys, NULL, NULL, NULL, NULL) < 0) {
		throw SocketPanic(0, "Certfile failed...\n");
	}
#endif
#ifdef SSLSERVER
	sessionId = NULL;
	static char keyfile[] = "CERTIFICATE.PEM";
	if (matrixSslReadKeys(&keys, keyfile, keyfile, NULL, NULL) < 0) {
		throw SocketPanic(0, "Certfile failed...\n");
	}
#endif

	SOCKADDR_IN		serverSockAddr;
	memset(&serverSockAddr, 0, sizeof(serverSockAddr));

	serverSockAddr.sin_port = htons(cPort);
	serverSockAddr.sin_family = AF_INET;
	serverSockAddr.sin_addr.s_addr = htonl(INADDR_ANY);

	listenSocket=socket(AF_INET, SOCK_STREAM, 0);
	if(listenSocket == INVALID_SOCKET)
	{
		throw SocketPanic(0,"ERROR:socket unsuccessful in TCPTunnelServer\n");
	}

	status = bind(
		listenSocket, (LPSOCKADDR)&serverSockAddr, sizeof(serverSockAddr));
	if(status == SOCKET_ERROR)
	{
		throw SocketPanic(0,"ERROR:bind unsuccessful in TCPTunnelServer\n");
	}
	
	status = listen(listenSocket, 1);
	if(status == SOCKET_ERROR)
	{
		throw SocketPanic(0, "ERROR:listen unsuccessful in TCPTunnelServer\n");
	}
}

static int certChecker(sslCertInfo_t *cert, void *arg)
{
	sslCertInfo_t	*next;
/*
	Make sure we are checking the last cert in the chain
*/
	next = cert;
	while (next->next != NULL) {
		next = next->next;
	}
	return next->verified;
}	

TCPTunnelServer::connect()
{
	short cipherSuite=0;
	unsigned long destAddr = inet_addr(BackEndServerIPAddr);

	struct in_addr iaHost;
	LPHOSTENT lpHostEntry;

	struct in_addr *pinAddr;
	
	iaHost.s_addr = inet_addr(BackEndServerIPAddr);
	if (iaHost.s_addr == INADDR_NONE)
	{
		lpHostEntry = gethostbyname(BackEndServerIPAddr);

		if (lpHostEntry == NULL)
			throw SocketPanic(0,"ERROR: gethostbyname unsuccessful\n");

		pinAddr = (LPIN_ADDR)lpHostEntry->h_addr_list[0];
		destAddr = inet_addr(inet_ntoa(*pinAddr));

	}

	SOCKADDR_IN destSockAddr;

	memcpy(&destSockAddr.sin_addr, &destAddr, sizeof(destAddr));
	destSockAddr.sin_port = htons(BackEndServerPort);
	destSockAddr.sin_family = AF_INET;

	serverSocket = socket(AF_INET, SOCK_STREAM, 0);
	if (serverSocket == INVALID_SOCKET)
	{
		shutdown(serverSocket,2);
		closesocket(serverSocket);
		throw SocketPanic(0,"ERROR: socket unsuccessful\n");
	}

	vnclog.Print(1, _T("Trying to connect to %s \n"),BackEndServerIPAddr);

	int status = ::connect(
		serverSocket, (LPSOCKADDR)&destSockAddr, sizeof(destSockAddr));

	if (status == SOCKET_ERROR)
	{
		cout << "Error number: " << GetLastError() << endl;

		shutdown(serverSocket,2);
		closesocket(serverSocket);

		shutdown(clientSocket,2);
		closesocket(clientSocket);
		
		throw SocketPanic(0,"ERROR: connect unsuccessful\n");
	}
#ifdef SSLCLIENT
	if (sslConnect(&conn, serverSocket, keys, sessionId, cipherSuite, certChecker) < 0) 
		{
				shutdown(serverSocket,2);
				closesocket(serverSocket);
				shutdown(clientSocket,2);
				closesocket(clientSocket);
				throw SocketPanic(0,"SSL error Error connecting to \n");
			}
#endif
}


unsigned int __stdcall _digTunnel(void *tcpTunnelServer)
{
	TCPTunnelServer* tc = (TCPTunnelServer *)tcpTunnelServer;
	
	try
	{
		tc->connect();
		tc->digTunnel();
		_endthreadex(0);
	}
	catch(SocketPanic socketPanic)
	{
		vnclog.Print(1, _T("%s\n"),socketPanic.reason());
	}
	catch(ThreadPanic threadPanic)
	{
		vnclog.Print(1, _T("%s\n"),threadPanic.reason());
	}
	
	return 0;
}


TCPTunnelServer::digTunnel()
{
	TCPTunnel tunnel = TCPTunnel(clientSocket, serverSocket,conn,sessionId,keys);
	tunnel.start();
	vnclog.Print(1, _T("This TCPTunnel is be destructed\n"));
}


TCPTunnelServer::start()
{
//	int rc;
	int flags = 0;
	SOCKADDR_IN		clientSockAddr;
	int				addrLen=sizeof(SOCKADDR_IN);
	
	while(1)
	{
		clientSocket 
			= accept(listenSocket,(LPSOCKADDR)&clientSockAddr, &addrLen);
		if (clientSocket == INVALID_SOCKET)
		{
			shutdown(clientSocket,2);
			closesocket(clientSocket);
			
			throw SocketPanic(0,"ERROR: accept unsuccessful\n");
		}
#ifdef SSLSERVER
		if ((rc = sslAccept(&conn, clientSocket, keys, certChecker, flags)) != 0) {
				shutdown(clientSocket,2);
				closesocket(clientSocket);
			
			throw SocketPanic(0,"ERROR: accept unsuccessful\n");
			}
#endif

		unsigned threadID;

		HANDLE threadHandle
			= (HANDLE)_beginthreadex(NULL, 0, &_digTunnel, this, 0, &threadID); 

		WaitForSingleObject( threadHandle,INFINITE);
		break;
		if (threadHandle == 0)
		{
			shutdown(clientSocket,2);
			closesocket(clientSocket);
		}
	}
}


TCPTunnelServer::close()
{
	matrixSslFreeKeys(keys);
	matrixSslClose();
}


TCPTunnel::TCPTunnel(SOCKET cs, SOCKET ss,sslConn_t *cnn,sslSessionId_t		*sId,sslKeys_t			*kys)
{
	clientSocket = cs;
	serverSocket = ss;
	conn = cnn;
	sessionId=sId;
	keys=kys;
	lifeFlag = true;
}

unsigned int __stdcall _returnWay( void* tcpTunnel )
{
	TCPTunnel* tt = (TCPTunnel *)tcpTunnel;

	try
	{
		tt->returnWay();
		_endthreadex(0);
	}
	catch(SocketPanic socketPanic)
	{
		vnclog.Print(1, _T("%s\n"),socketPanic.reason());
	}
	catch(ThreadPanic threadPanic)
	{
		vnclog.Print(1, _T("%s\n"),threadPanic.reason());
	}
		
	return 0;
}


void
TCPTunnel::returnWay()
{
	int numberRecv;
	int status;
	while(lifeFlag)
	{
		// From BackEndServer to Client

		char recvData[MAXBUFLEN];
#ifdef SSLSERVER
		int numberRecv = recv(serverSocket, recvData, MAXBUFLEN, 0);
#else
		readMore:
		if ((numberRecv = sslRead(conn, recvData, MAXBUFLEN, &status)) > 0) {
			
		} else {
			if (numberRecv < 0) {
//				vnclog.Print(LL_STATE, VNCLOG("sslRead error.  dropping connection.\n"));
			}
			if (numberRecv < 0 || status == SSLSOCKET_EOF ||
					status == SSLSOCKET_CLOSE_NOTIFY) {
				if (conn) if(conn->fd) socketShutdown(conn->fd);
				if (conn) if (conn->ssl)sslFreeConnection(&conn);
				conn=NULL;
				lifeFlag = false;
				break;
			}
			goto readMore;
		}
#endif

		if ((numberRecv == SOCKET_ERROR) || (numberRecv == 0))
		{
			lifeFlag = false;
			break;
		}
#ifdef SSLCLIENT		
		int numberServ = send(clientSocket, recvData, numberRecv, 0);
		if (numberServ == SOCKET_ERROR)
		{
			lifeFlag = false;
			break;
		}
#else
		writeMore:
		int numberSend = sslWrite(conn, recvData, numberRecv, &status);
		if (numberSend == 0) {
			goto writeMore;
		}

		if (numberSend == SOCKET_ERROR || numberSend<0)
		{
			sslFreeConnection(&conn);
			lifeFlag = false;
			break;
		}
#endif
	}
	
	return;	
}

void
TCPTunnel::start()
{
	unsigned  threadID;
	int status;

	HANDLE	tunnelThreadHandle
		= (HANDLE)_beginthreadex(NULL, 0, &_returnWay, this, 0, &threadID); 
	
	if (tunnelThreadHandle == 0)
	{
		shutdown(serverSocket,2);
		closesocket(serverSocket);

		shutdown(clientSocket,2);
		closesocket(clientSocket);
		throw ThreadPanic(0,"returnWay thread failed\n");
	}
	char recvData[MAXBUFLEN];
	strcpy(recvData,"testB");
	sslWrite(conn, recvData, 5, &status);
	while(lifeFlag)
	{
		// From Client to BackEndServer
#ifdef SSLCLIENT
		int numberRecv = recv(clientSocket, recvData, MAXBUFLEN, 0);
//		vnclog.Print(LL_STATE, VNCLOG("numberRecv %i\n"),numberRecv);
		if ((numberRecv == SOCKET_ERROR) || (numberRecv == 0))
		{	
			lifeFlag = false;
			break;
		}
#else
		readMore:
		int numberRecv;
		if ((numberRecv = sslRead(conn, recvData, MAXBUFLEN, &status)) > 0) {
			vnclog.Print(LL_STATE, VNCLOG("numberRecv %i\n"),numberRecv);
			
		} else {
			if (numberRecv < 0) {
				vnclog.Print(LL_STATE, VNCLOG("sslRead error.  dropping connection.\n"));
			}
			if (numberRecv < 0 || status == SSLSOCKET_EOF ||
					status == SSLSOCKET_CLOSE_NOTIFY) {
				socketShutdown(conn->fd);
				sslFreeConnection(&conn);
				lifeFlag = false;
				break;
			}
			goto readMore;
		}
#endif
#ifdef SSLSERVER		
		int numberSend = send(serverSocket, recvData, numberRecv, 0);
		if (numberSend == SOCKET_ERROR || numberSend<0)
		{
			lifeFlag = false;
			break;
		}
#else
		writeMore:
		int numberSend;
		if(conn) numberSend= sslWrite(conn, recvData, numberRecv, &status);
		else numberSend = SOCKET_ERROR;
//		vnclog.Print(LL_INTERR, VNCLOG("numberSend ssl %i\n"),numberSend);
		if (numberSend == 0) {
			goto writeMore;
		}

		if (numberSend == SOCKET_ERROR || numberSend<0)
		{
			if (conn)sslFreeConnection(&conn);
			lifeFlag = false;
			break;
		}
#endif
	}

	//WaitForSingleObject( tunnelThreadHandle, INFINITE );
	//CloseHandle( tunnelThreadHandle );

	shutdown(serverSocket,2);
	closesocket(serverSocket);

	shutdown(clientSocket,2);
	closesocket(clientSocket);

	//sslFreeConnection(&conn);
	matrixSslFreeSessionId(sessionId);
	if (conn && conn->ssl) {
		socketShutdown(conn->fd);
		sslFreeConnection(&conn);
	}

	WaitForSingleObject( tunnelThreadHandle, INFINITE );
	CloseHandle( tunnelThreadHandle );

}

unsigned int __stdcall _tcpMainThread(void *connectInfo)
{
	struct ConnectInfo *ci = (struct ConnectInfo *)connectInfo;

	TCPTunnelServer 
		tcpTunnelServer(ci->clientPort,ci->backEndServerIPAddr,ci->serverPort);
	try
	{
		tcpTunnelServer.start();
	}
	catch (SocketPanic socketPanic) 
	{
		vnclog.Print(1, _T("%s\n"),socketPanic.reason());
	}

	tcpTunnelServer.close();

	return(0);
}
//wsock32.lib kernel32.lib user32.lib advapi32.lib 
//wsock32.lib Libcmtd.lib Libcmt.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib 

void
OpenRegistry()
{
	regblocked=true;
	DWORD dw;
	hkLocal=NULL;
	
	if (RegCreateKeyEx(HKEY_CURRENT_USER,
		REGISTRY_KEY,
		0,REG_NONE, REG_OPTION_NON_VOLATILE,
		KEY_READ,
		NULL, &hkLocal, &dw) != ERROR_SUCCESS)

		return;

}

void
CloseRegistry()
{
	if (hkLocal != NULL) RegCloseKey(hkLocal);
	regblocked=false;
}

TCHAR *
LoadString(HKEY key, LPCSTR keyname)
{
	DWORD type = REG_SZ;
	DWORD buflen = 256*sizeof(TCHAR);
	TCHAR *buffer = 0;

	// Get the length of the string
	if (RegQueryValueEx(key,
		keyname,
		NULL,
		&type,
		NULL,
		&buflen) != ERROR_SUCCESS)
		return 0;

	if (type != REG_SZ)
		return 0;
	buflen = 256*sizeof(TCHAR);
	buffer = new TCHAR[buflen];
	if (buffer == 0)
		return 0;

	// Get the string data
	if (RegQueryValueEx(key,
		keyname,
		NULL,
		&type,
		(BYTE*)buffer,
		&buflen) != ERROR_SUCCESS) {
		delete [] buffer;
		return 0;
	}

	// Verify the type
	if (type != REG_SZ) {
		delete [] buffer;
		return 0;
	}

	return (TCHAR *)buffer;
}
LONG
LoadInt(HKEY key, LPCSTR valname, LONG defval)
{
	LONG pref;
	ULONG type = REG_DWORD;
	ULONG prefsize = sizeof(pref);

	if (RegQueryValueEx(key,
		valname,
		NULL,
		&type,
		(LPBYTE) &pref,
		&prefsize) != ERROR_SUCCESS)
		return defval;

	if (type != REG_DWORD)
		return defval;

	if (prefsize != sizeof(pref))
		return defval;

	return pref;
}
TCHAR*
Readsettings()
{
	TCHAR *value=NULL;
	OpenRegistry();
	if (hkLocal) value=LoadString (hkLocal, "ProxyServer");
	CloseRegistry();
	return value;
}

LONG
Readproxy(LONG returnvalue)
{
	OpenRegistry();
	if (hkLocal) returnvalue=LoadInt(hkLocal, "ProxyEnable",returnvalue);
	CloseRegistry();
	return returnvalue;
}

BOOL ParseDisplay(LPTSTR display, LPTSTR phost, int hostlen, int *pport) 
{
	int tmp_port;
	TCHAR *colonpos = _tcschr(display, L':');
    if (hostlen < (int)_tcslen(display))
        return FALSE;

    if (colonpos == NULL)
	{
		// No colon -- use default port number
        tmp_port = HTTP_PORT;
		_tcsncpy(phost, display, MAX_HOST_NAME_LEN);
	}
	else
	{
		_tcsncpy(phost, display, colonpos - display);
		phost[colonpos - display] = L'\0';
		if (colonpos[1] == L':') {
			// Two colons -- interpret as a port number
			if (_stscanf(colonpos + 2, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;
		}
		else
		{
			// One colon -- interpret as a display number or port number
			if (_stscanf(colonpos + 1, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;

			// RealVNC method - If port < 100 interpret as display number else as Port number
			if (tmp_port < 100)
				tmp_port += HTTP_PORT;
		}
	}
    *pport = tmp_port;
    return TRUE;
}

BOOL ParseDisplay2(LPTSTR display, LPTSTR phost, int hostlen, int *pport) 
{
	int tmp_port;
	TCHAR *colonpos = _tcschr(display, L':');
    if (hostlen < (int)_tcslen(display))
        return FALSE;

    if (colonpos == NULL)
	{
		// No colon -- use default port number
        tmp_port = HTTPS_PORT;
		_tcsncpy(phost, display, MAX_HOST_NAME_LEN);
	}
	else
	{
		_tcsncpy(phost, display, colonpos - display);
		phost[colonpos - display] = L'\0';
		if (colonpos[1] == L':') {
			// Two colons -- interpret as a port number
			if (_stscanf(colonpos + 2, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;
		}
		else
		{
			// One colon -- interpret as a display number or port number
			if (_stscanf(colonpos + 1, TEXT("%d"), &tmp_port) != 1) 
				return FALSE;

			// RealVNC method - If port < 100 interpret as display number else as Port number
			if (tmp_port < 100)
				tmp_port += HTTPS_PORT;
		}
	}
    *pport = tmp_port;
    return TRUE;
}


#if _NTS
DWORD ServiceThread(LPDWORD param)  // This is for NT Service
#else
DWORD WINAPI sslmain(LPVOID lpParameter)
#endif
{
	unsigned threadID;
	struct ConnectInfo tcpCi[30];

	int tcpCounter = 1;
	tcpCi[0].clientPort = atoi("59001");
	strcpy(tcpCi[0].backEndServerIPAddr, "127.0.0.1");
	tcpCi[0].serverPort = atoi("99912");
	vnclog.Print(1, _T("%s\t"),"59001");
	vnclog.Print(1, _T("%s\t"),"127.0.0.1");
	vnclog.Print(1, _T("%s\n"),"99912");

	HANDLE threadHandle[100];

	for(int i = 0; i < tcpCounter; i++)
	{
		threadHandle[i]
			= (HANDLE)_beginthreadex(
			NULL, 0, &_tcpMainThread, &tcpCi[i], 0, &threadID); 
	}
	
		
	WaitForMultipleObjects(
		(tcpCounter), threadHandle, TRUE,INFINITE);

	for(i = 0; i < (tcpCounter); i++)
		CloseHandle(threadHandle[i]);

	return 0;
}

#if _NTS
DWORD ServiceThread(LPDWORD param)  // This is for NT Service
#else
DWORD WINAPI sslmain2(LPVOID lpParameter)
#endif
{
	unsigned threadID;
	struct ConnectInfo tcpCi[30];

	int tcpCounter = 1;
	tcpCi[0].clientPort = atoi("59001");
	strcpy(tcpCi[0].backEndServerIPAddr, remotehost3);
	tcpCi[0].serverPort = remoteport3;
	vnclog.Print(1, _T("%s\t"),"59001");
	vnclog.Print(1, _T("%s\t"),remotehost3);
	vnclog.Print(1, _T("%i\n"),remoteport3);

	HANDLE threadHandle[100];

	for(int i = 0; i < tcpCounter; i++)
	{
		threadHandle[i]
			= (HANDLE)_beginthreadex(
			NULL, 0, &_tcpMainThread, &tcpCi[i], 0, &threadID); 
	}
	
		
	WaitForMultipleObjects(
		(tcpCounter), threadHandle, TRUE,INFINITE);

	for(i = 0; i < (tcpCounter); i++)
		CloseHandle(threadHandle[i]);

	return 0;
}

/*int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)*/

unsigned int __stdcall _tcpMainThreadHead(void *connectInfo)
{
 	// TODO: Place code here.
	g_hInst=m_hInstResDLL;
	TCHAR *proxy=NULL;
	proxy=Readsettings();

	long ProxyEnable=0;
	ProxyEnable=Readproxy(ProxyEnable);
	TCHAR remotehost[256];
	int remoteport=0;
	TCHAR remotehost2[256];
	int remoteport2=0;
//	char* p = strrchr(GetCommandLine(), '\\');
//	char* pp = strrchr(p, ' ');
//	strcpy(viewerhost,pp);
	
	TCHAR * pch;
	TCHAR tempchar1[256];
	TCHAR tempchar2[256];
	_tcscpy(tempchar1,"");
	_tcscpy(tempchar2,"");
	if (proxy!=NULL)
	{
	pch = _tcstok (proxy,";");

	
	if (_tcsstr(pch,"http=")!=NULL)
	{
		_tcscpy(tempchar1,pch);
	}
	if (_tcsstr(pch,"https=")!=NULL)
	{
		_tcscpy(tempchar2,pch);
	}
	if (_tcsstr(pch,"=")==NULL)
	{
		_tcscpy(tempchar2,pch);
	}

	while (pch != NULL)
		{
			pch = _tcstok (NULL, ";");
			if (pch != NULL)
			{
				if (_tcsstr(pch,"http=")!=NULL)
					{
						_tcscpy(tempchar1,pch+5);
					}
				if (_tcsstr(pch,"https=")!=NULL)
					{
						_tcscpy(tempchar2,pch+6);
					}

			}
	}
	ParseDisplay(tempchar1, remotehost, 255, &remoteport);
	ParseDisplay2(tempchar2, remotehost2, 255, &remoteport2);
	}
	ParseDisplay2(g_proxyhost, remotehost3, 255, &remoteport3);
	//sslmain();
	HANDLE ThreadHandle[2];
	ULONG i;
	if (ProxyEnable)
	{
	ThreadHandle[0] = CreateThread(NULL, 0, sslmain, NULL, 0, &i);
	char *arguments[] = {"preconnect","-d","-p","99912","-H",tempchar2,remotehost3,"443"};
	char *arguments2[] = {"preconnect","-d","-p","99912","-S",tempchar2,remotehost3,"443"};
	if (remoteport2!=1080) mainconnect(8,arguments);
	else mainconnect(8,arguments2);
	}
	else
	{
		ThreadHandle[0] = CreateThread(NULL, 0, sslmain2, NULL, 0, &i);
	}
	DWORD result=WAIT_TIMEOUT;
	while (result==WAIT_TIMEOUT)
	{
		result=WaitForMultipleObjects(1, ThreadHandle, TRUE,100);
		if (g_stop) break;
	}

	delete [] proxy;
	return 0;
}



